let s = '';
function ic() {
    if (/`[\w|\t|\r|\W]*`/.test(s)) {
        s = s.replace('`', '<code>').replace('`', '</code>');
        ic();
    }
}
function b() {
    if (s.includes('**')) {
        s = s.replace('**', '<strong>').replace('**', '</strong>');
        b();
    }
}
function i() {
    if (s.includes('_')) {
        s = s.replace('_', '<em>').replace('_', '</em>');
        i();
    }
}
function st() {
    if (s.includes('~~')) {
        s = s.replace('~~', '<span style="text-decoration:line-through">').replace('~~', '</span>');
        st();
    }
}
function mlc() {
    if (s.includes('```')) {
        s = s.replace('```', '<codea>').replace('```', '</codea>');
        mlc();
    }
}
function mcr() {
    if (s.includes('<codea>')) {
        s = s.replaceAll('<codea>', '<pre><code>').replaceAll('</codea>', '</code></pre>');
    }
}
function blockQuote(str) {
    if (str.trim().startsWith('&gt;')) {
        str = str.replace('&gt;', '<blockquote>');
        if (str.includes('<br>')) {
            str = str.replace('<br>', '</blockquote>');
        } else if (str.includes('<p>')) {
            str = str.replace('<p>', '</blockquote><p>');
        } else {
            str = str + '</blockquote>';
        }
    }
    return str;
}
function convertMarkdown(textbox) {
    s = textbox.replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/ /g, '&nbsp;');
    s = s.replaceAll("'", '&#39;');
    s = s.replaceAll('"', '&#34;');
    s = s.replaceAll(',', '&#44;');
    s = s.replaceAll('\n\n', '<br> <br> ');
    //s = s.replaceAll('\n', '<br>');
    s = s.replace(/'/g, "\\'");
    if (!s.includes('\n') && !s.includes('\r')) {
        s = '<p>' + s + '</p>';
    }
    s = s.replaceAll('\n\n', '<p>').replaceAll('<p></p>', '');
    s = s.replaceAll('\n\r', '<br>');
    b();
    i();
    st();
    s = s.replaceAll('&nbsp;', ' ');
    let h = [{
        md: '###### ',
        tag: '<h6>',
        tgn: 'h6'
    }, {
        md: '##### ',
        tag: '<h5>',
        tgn: 'h5'
    }, {
        md: '#### ',
        tag: '<h4>',
        tgn: 'h4'
    }, {
        md: '### ',
        tag: '<h3>',
        tgn: 'h3'
    }, {
        md: '## ',
        tag: '<h2>',
        tgn: 'h2'
    }, {
        md: '# ',
        tag: '<h1>',
        tgn: 'h1'
    }];
    s = s.replace('\n\r', '<br>');
    let sA = s.split('\n');
    for (let i = 0; i < sA.length; i++) {
        if (/`[\w|\t|\r|\W]*`/.test(s)) {
            if (sA[i].includes('```')) {
                let nASt = '';
                nAr = sA[i].split(' ');
                for (let j = 0; j < nAr.length; j++) {
                    if (nAr[j].includes('&#39;') || nAr[j].includes('&#34;')) {
                        nAr[j] = nAr[j].replaceAll('`', 'nsbkey1-');
                    }
                    nASt += nAr[j] + ' ';
                }
                sA[i] = nASt;
            }
        }
        // if (/\[[\w|\t|\r|\W](\w|\t|\r|\W)\]*/g.test(sA[i])) {
        //     let u = sA[i].match(/\((.*)\)/);
        //     if (!sA[i].includes('![')) {
        //         sA[i] = sA[i].replace('[', '<a href="' + u[1] + '" target="_blank">').replace(']', '</a>').replace(/\((.*)\)/g, '');
        //     } else {
        //         let aTx = sA[i].match(/\[(.*)\]/);
        //         sA[i] = sA[i].replace(/\[(.*)\]/g, '<img src="' + u[1] + '" alt="' + aTx[1] + '">').replace(/\((.*)\)/g, '').replace('!', '');
        //     }
        // }
        sA[i] = blockQuote(sA[i]);
        if (sA[i].trim().includes(' #')) {
            sAS = sA[i].split(' #');
            for (let j = 0; j < sAS.length; j++) {
                if (j > 0) {
                    sAS[j] = '#' + sAS[j];
                }
                for (let k = 0; k < h.length; k++) {
                    if (sAS[j].includes(h[k].md)) {
                        let regex = new RegExp(h[k].md,'g');
                        sAS[j] = sAS[j].trim();
                        sAS[j] = '\n' + sAS[j].replace(regex, h[k].tag) + h[k].tag.replace('<', '</');
                    }
                }
            }
            sA[i] = sAS.toString().replace(/,/g, '\n');
        }
        for (let j = 0; j < h.length; j++) {
            if (sA[i].includes(h[j].md)) {
                let regex = new RegExp(h[j].md,'g');
                sA[i] = sA[i].trim();
                sA[i] = '\n' + sA[i].replace(regex, h[j].tag) + h[j].tag.replace('<', '</');
            }
        }
    }
    s = sA.toString().replaceAll(/,/g, '<br>').replaceAll('&nbsp;', ' ').replaceAll('</h1><br>', '</h1>').replaceAll('</h2><br>', '</h2>').replaceAll('</h3><br>', '</h3>').replaceAll('</h4><br>', '</h4>').replaceAll('</h5><br>', '</h5>').replaceAll('</h6><br>', '</h6>').replaceAll('<br><br>', '<br>');
    mlc();
    mcr();
    ic();
    s = s.replaceAll('<code></code>', '').replaceAll('nsbkey1-', '`');
    sA = s.split('<p>');
    let news = '';
    for (let i = 0; i < sA.length; i++) {
        if (sA[i].trim().includes('* ')) {
            news += '<ul>' + sA[i].replaceAll('*', '<li>').replaceAll('<br>', '</li>') + '</ul>';
            console.log(news);
            sA[i] = news;
        }
        sA[i] = blockQuote(sA[i]);
    }
    return sA.toString().replaceAll(/,/g, '<p>');
}

