#!/usr/bin/python3

import sys
from http.server import SimpleHTTPRequestHandler
from socketserver import TCPServer
import os
import webbrowser

PORT = int(sys.argv[1])
PATH = "/usr/include/vicharak-chat/front-end"

os.chdir(PATH)
MyHandler = SimpleHTTPRequestHandler
# class MyHandler(SimpleHTTPRequestHandler):
#     def do_GET(self):
#         #if self.path =="/":  # Serve the HTML file
#         #    self.path = "index.html"  # Serve the HTML file
#         os.chdir(PATH)
#         self.path = "index.html"
#         return super().do_GET()
#     
#     def log_message(self, format, *args):
#         pass  # Override to suppress logging
# Start the server
with TCPServer(("", PORT), MyHandler) as httpd:
    print(f"Serving on port {PORT}")
    url = f"http://localhost:{PORT}"
    print(f"Serving on {url}")
    # Open the default browser
    webbrowser.open(url)
    
    httpd.serve_forever()
